package multiplebarcode.multiplebarcode;

import android.app.Activity;
import android.content.Intent;
import android.util.Log;

import java.util.ArrayList;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.plugin.common.PluginRegistry;

/**
 * MultiplebarcodePlugin
 */
public class MultiplebarcodePlugin implements MethodCallHandler, PluginRegistry.ActivityResultListener {
    /**
     * Plugin registration.
     */
    Result result;
    Activity activity;

    MultiplebarcodePlugin(Activity activity) {
        this.activity = activity;
    }

    public static void registerWith(Registrar registrar) {
        final MethodChannel channel = new MethodChannel(registrar.messenger(), "multiplebarcode");
        if (registrar.activity() != null) {
            MultiplebarcodePlugin plugin = new MultiplebarcodePlugin(registrar.activity());
            channel.setMethodCallHandler(plugin);
            registrar.addActivityResultListener(plugin);
        }
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        if (call.method.equals("scanBarcode")) {
            this.result = result;
            startActivityScan();
        } else {
            result.notImplemented();
        }
    }

    public void startActivityScan() {
        Intent i = new Intent(activity, BarcodeCaptureActivity.class);
        activity.startActivityForResult(i, 100);
    }

    @Override
    public boolean onActivityResult(int code, int resultCode, Intent data) {
        Log.e("-------------------", resultCode+ " YUP YUP " + code);
        if (code == 100) {
            if (resultCode == Activity.RESULT_OK) {
                Log.e("OK", data.getSerializableExtra("Barcode").toString());
                ArrayList<String> barcode = (ArrayList<String>) data.getSerializableExtra("Barcode");
                this.result.success(barcode);
            } else {
                this.result.success(new ArrayList<String>());
            }
            return true;
        }
        return false;
    }
}
